#include <linux/init.h>
#include <linux/kernel.h>
#include <asm/bootinfo.h>
#include <linux/interrupt.h>
#include <asm/time.h>
#include <asm/traps.h>

extern void mips_reboot_setup(void);
extern void mips_timer_setup(struct irqaction *irq);
static void vsc452_be_init(void);

#ifdef CONFIG_KGDB
extern void kgdb_config(void);
#endif

const char *get_system_type(void)
{
	return "VSC452";
}

void __init vsc452TimeInit(void)
{
	// clocked @ 300MHz, counter counts every other clock
	mips_hpt_frequency = 300e6/2;
}
static void vsc452_be_init(void)
{
}
 
int vsc452_be_handler (struct pt_regs *regs, int is_fixup)
{
        return (is_fixup ? MIPS_BE_FIXUP : MIPS_BE_FATAL);
}

void __init plat_mem_setup(void)
{
	console_verbose();

#ifdef CONFIG_KGDB
	kgdb_config ();
#endif

	mips_reboot_setup();
	board_be_init = vsc452_be_init;
	board_be_handler = vsc452_be_handler;
	return;
}
