/*
 * Netapp MAP for NAND 
 *
 * Copyright (C) 2008 American Megatrends Inc
 *
 */

#include <linux/init.h>
#include <linux/types.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/vmalloc.h>
#include <linux/slab.h>
#include <linux/errno.h>
#include <linux/string.h>
#include <linux/mtd/mtd.h>
#include <linux/mtd/nand.h>
#include <linux/mtd/partitions.h>
#include <linux/delay.h>


int
CreateNandPartitions(struct mtd_partition *part,unsigned long nandsize)
{
	part[0].name 	= "Primary Kernel";
	part[0].offset 	= 0;
	part[0].size 	= 8*1024*1024;

	part[1].name 	= "Primary Rootfs";
	part[1].offset 	= 8*1024*1024;
	part[1].size 	= (nandsize/4)-(8*1024*1024);
	
	part[2].name 	= "Secondary Kernel";
	part[2].offset 	= nandsize/4;
	part[2].size 	= 8*1024*1024;

	part[3].name 	= "Secondary Rootfs";
	part[3].offset 	= (nandsize/4) + (8*1024*1024);
	part[3].size 	= (nandsize/4) - (8*1024*1024);

	part[4].name 	= "Volatile FileSystem";
	part[4].offset 	= (nandsize/2);
	part[4].size 	= (nandsize/4);

	part[5].name 	= "Support Apps";
	part[5].offset 	= (nandsize/4) * 3;
	part[5].size 	= (nandsize/4);

	return 6;
}
